# комментарии начинаются с # и идут до конца строки

# скрипт GUI, нужен пакет Tk
package require Tk
# загрузим темы awthemes 
# и выбираем тёмную тему awdark
package require awthemes
ttk::setTheme awdark
# будут подсказки к полям
package require baltip

# создаём все элементы
# окно с внутренним именем .form
toplevel .win
# внутри него невидимый фрейм
ttk::frame .win.carea
# уже в котором наш фрейм с рамкой и заголовком
ttk::labelframe .win.carea.form -text "заголовок"
# и кнопки cancel,ok (хотя их тоже можно было в отдельный фрейм)
ttk::button .win.carea.cancel -text "cancel"
ttk::button .win.carea.ok -text "ok"
# первое поле внутри формы - текущее время
ttk::label .win.carea.form.time 
# внутри формы - подсказка к полю ввода и само поле ввода
ttk::label .win.carea.form.prompt -text "подсказка"
ttk::entry .win.carea.form.entry
# дополнительно - ещё одно значение
ttk::label .win.carea.form.prompt2 -text "значение"
ttk::entry .win.carea.form.entry2

# теперь каждый фрейм сверстаем как таблицы 
# внутри окна у нас только один фрейм на всю единственную ячейку таблицы
grid .win.carea -row 0 -column 0 -sticky "nsew"
# разрешим строке и колонке растягиваться
grid rowconfigure .win 0 -weight 1
grid columnconfigure .win 0 -weight 1

# теперь фрейм .win.carea
grid .win.carea.form -row 0 -column 0 -columnspan 3 -sticky "nsew"
grid .win.carea.cancel -row 1 -column 1 -sticky "nsew"
grid .win.carea.ok -row 1 -column 2 -sticky "nsew"
grid columnconfigure .win.carea 0 -uniform same -weight 1
grid columnconfigure .win.carea 1 -uniform same -weight 1
grid columnconfigure .win.carea 2 -uniform same -weight 1
grid rowconfigure .win.carea 0 -weight 1

# и собственно элементы формы
grid .win.carea.form.time -row 0 -column 1 -sticky "nsew"
grid .win.carea.form.prompt -row 1 -column 0 -sticky "nsew"
grid .win.carea.form.entry -row 1 -column 1 -sticky "nsew"
grid .win.carea.form.prompt2 -row 2 -column 0 -sticky "nsew"
grid .win.carea.form.entry2 -row 2 -column 1 -sticky "nsew"
grid columnconfigure .win.carea.form 0 -weight 1
grid columnconfigure .win.carea.form 1 -weight 2

set currentTime 0	; # текущее время
# процедура обновления виджета времени
proc update_time {} {
	global currentTime
	# получаем текущее системное время
	set now [ clock seconds ]	
	# если время поменялось - обновим поле
	if { $now != $currentTime } {
		# предварительно сформатируем значение времени
		set text [ clock format $now -format "%T" ]
		.win.carea.form.time configure -text $text
		set currentTime $now
	}
	# будем повторять раз в 30 млисекунд
	after 30 update_time
}
# и сразу начнём обновления поля
update_time
# настроиваем подсказки к полям
baltip tip .win.carea.form.time  "Системное время"
baltip tip .win.carea.form.prompt1 "Самое первое поле"
baltip tip .win.carea.form.entry1 "введите текст"
baltip tip .win.carea.form.entry2 "введите значение"
baltip tip .win.carea.cancel "очистить форму"
baltip tip .win.carea.ok "передать в MQL"
# скрываем основное окно
wm withdraw .
# запрещаем закрывать форму
# (вместо закрытий, просто свернём)
wm protocol .win WM_DELETE_WINDOW { wm iconify .win }

# действия для кнопки Ok
# создадим переменную
set BOX {}
# установим что пока нет событий
set FLAGS 0
.win.carea.ok configure -command {
	# получаем текст из поля ввода
	set text [ .win.carea.form.entry get ]
	# удалим лишние пробелы
	set text [ string trim $text ]
	# и второе поле так-же
	set value [ string trim [ .win.carea.form.entry2 get ] ]
	# если не пусто - зададим значение глобальной переменной
	# и икрементируем FLAGS
	if { $text != {} } {
		global BOX 
		global FLAGS
		set BOX [ list 1 $text $value ]
		incr FLAGS
	}
}
# и заодно уж cancel будет очищать поле ввода
.win.carea.cancel configure -command {
	.win.carea.form.entry delete 0 end
}
